/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu Mar 11 02:34:11 HKT 2004
    copyright            : (C) |YEAR| by ro2004    email                : root@DMB192
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #include <string.h>
#include <stdlib.h>
#include "../subPrograms/interpreter/bas.h"
#include "../subPrograms/interpreter/configIO.h" 
#include "../subPrograms/utilities/fastaLoader.h"
#include "../subPrograms/primer3/primer_main.h"
#include "../subPrograms/blast/blast_main.h"
#include "../subPrograms/interpreter/settingloader.h"

#include <iomanip>
#define DEFAULT_CONF_PATH "primerDesigner.conf"

#ifdef GUI_VERSION
	#define GUIV_SHOWPROGRESS(str)  SHOWPROGRESSMSG(str)
#else
	#define GUIV_SHOWPROGRESS(str)
#endif

struct Primer_pair
{
  Primer_data* l;
  Primer_data* r;
  int pscore;
};

void displayResult(primerSet& pmrSet,fastaLoader& _fasta)
{


cout<<endl<<"Displaying Result:"<<endl;
  
  string prev="";
  int start=0;
   string prev2="";
  int start2=0; 
  
  multimap<double,Primer_data*> orderedLeft;
  multimap<double,Primer_data*> orderedRight; 
  primerSet::iterator i,j;  
  
  for(i=pmrSet.leftPrimers.begin(),
      j=pmrSet.rightPrimers.begin();
  	i!=pmrSet.leftPrimers.end(),
	j!=pmrSet.rightPrimers.end();
	i++,
	j++
	)
	{
	  orderedLeft.insert(multimap<double,Primer_data*>::value_type((*i).score,&(*i)));
	  orderedRight.insert(multimap<double,Primer_data*>::value_type((*j).score,&(*j)));
//	 cout<<"Sss "<<(*i).svec.size()<<endl;
	}
  

  
	
cout<<"LEFT TABLE"<<endl;
cout<<"**********************"<<endl;
cout<<"S{1->n}S{1->L(i)}(1.25^(N-i)*[s(i)='-']\t"
	<<"pos,len Sequence(s)\t"
	<<"[Base Hits:3'->5' ]S{1->n}[s(i)='-']"
	<<endl;
cout<<"-----------------------"<<endl<<endl;
for(multimap<double,Primer_data*>::iterator k=orderedLeft.begin();
    k!=orderedLeft.end();
    k++)
    {
 
 //  cout<<"TTTTTTtt "<<(*k).second->svec.size()<<endl;   
     
      if(prev!=(*k).second->seq.toString() || start!=(*k).second->position)
      {
     	 cout<<setprecision(8)<<(*k).second->score<<"\t";
	 
	 (*k).second->print(PRINT_MODE_SHOW_BASE_SCORE,&_fasta);
	 
	 
	 cout<<endl;
	 }
      
      prev=(*k).second->seq.toString();
      start=(*k).second->position;   
    }

cout<<"-----------------------"<<endl<<endl;

cout<<"RIGHT TABLE"<<endl;
cout<<"**********************"<<endl; 
cout<<"S{1->n}S{1->L(i)}(1.25^(N-i)*[s(i)='-']\t"
	<<"pos,len Sequence(s)\t"
	<<"[Base Hits:3'->5' ]S{1->n}[s(i)='-']"
	<<endl;
cout<<"-----------------------"<<endl<<endl;   
for(multimap<double,Primer_data*>::iterator k=orderedRight.begin();
    k!=orderedRight.end();
    k++)
    {
      if(prev!=(*k).second->seq.toString() || start!=(*k).second->position)
      {
	  cout<<setprecision(8)<<(*k).second->score<<"\t";
	  
	  (*k).second->print(PRINT_MODE_SHOW_BASE_SCORE,&_fasta);
	  
	  cout<<endl;
       }
      prev=(*k).second->seq.toString();
      start=(*k).second->position;   
    }  
    
 cout<<"-----------------------"<<endl<<endl; 
 

 
  multimap<double,Primer_data*> orderedTotal;
 
 double pscore;
for(multimap<double,Primer_data*>::iterator k=orderedLeft.begin();
    k!=orderedLeft.end();
    k++)
    {   pscore=(*k).second->score+(*k).second->partner->score;
 	orderedTotal.insert(multimap<double,Primer_data*>::value_type(pscore,(*k).second));
    
    }
  
cout<<"ORIGINALLY-PAIRED TABLE"<<endl;
cout<<"**********************"<<endl;
cout<<"S1+S2(S1,S2)\t"
	<<"pos1,len1 Sequence(s1)\t"
	<<"pos2,len2 Sequence(s2)\t"
	<<endl;
	
cout<<"-----------------------"<<endl<<endl;
for(multimap<double,Primer_data*>::iterator k=orderedTotal.begin();
    k!=orderedTotal.end();
    k++)
    {
      cout<<setprecision(8)<<(*k).first<<"("<<(*k).second->score<<","<<(*k).second->partner->score<<")"<<"\t";
      (*k).second->print(PRINT_MODE_SIMPLE,&_fasta);
      cout<<"\t";
      (*k).second->partner->print(PRINT_MODE_SIMPLE,&_fasta);
      cout<<endl;
    
    }

cout<<"-----------------------"<<endl<<endl;

cout<<"BEST-PAIRED TABLE"<<endl;
cout<<"**********************"<<endl;
cout<<"S1+S2(S1,S2)\t"
	<<"pos1,len1 Sequence(s1)\t"
	<<"pos2,len2 Sequence(s2)\t"
	<<endl;
	
cout<<"-----------------------"<<endl<<endl;

multimap<double,Primer_data*>::iterator l;
multimap<double,Primer_data*>::iterator r;


Primer_pair pp;
multimap<double,Primer_pair> ppm;


for(l=orderedLeft.begin();l!=orderedLeft.end();l++)
  for(r=orderedRight.begin();r!=orderedRight.end();r++)
   {
   
      pp.l=(*l).second;
      pp.r=(*r).second;
      pp.pscore=(*l).second->score+(*r).second->score;
      
      ppm.insert(multimap<double,Primer_pair>::value_type(pp.pscore,pp));
      
   }

   
 prev="";
 start=0;
 prev2="";
 start2=0;
   
 for(multimap<double,Primer_pair>::iterator ppi=ppm.begin();
 	ppi!=ppm.end();
	ppi++)
	{
	
	
	if(prev!=(*ppi).second.l->seq.toString() || start!=(*ppi).second.l->position || prev2!=(*ppi).second.r->seq.toString() || start2!=(*ppi).second.r->position )
	{
      cout<<setprecision(8)<<(*ppi).first<<"("<<(*ppi).second.l->score<<","<<(*ppi).second.r->score<<")"<<"\t";
      (*ppi).second.l->print(PRINT_MODE_SIMPLE,&_fasta);
      cout<<"\t";
      (*ppi).second.r->print(PRINT_MODE_SIMPLE,&_fasta);
      cout<<endl;
      }
      prev=(*ppi).second.l->seq.toString();
      start=(*ppi).second.l->position;   
      prev2=(*ppi).second.r->seq.toString();
      start2=(*ppi).second.r->position;   
        
	
	
	}



cout<<"-----------------------"<<endl<<endl;


}

 settingLoader cio("CORE_SNP_CONTIG PATH,CORE_BLAST_CONTIG FILENAME,CORE_SNP_LOC");
  
  
void pd_loadSetting(int argc,char *argv[])
{

cio.loadFile(DEFAULT_CONF_PATH);	
cio.loadArgs(argc,argv);	


}

  typedef void (*perCallBack)(int,int);
  
  fastaLoader fasta;
  
  
#define ORI_53 0
#define ORI_35 1  
void write_input_for_extern_score(hitRecordSet &hrs,int orientation=ORI_53)
{

	string extinfile="plugin/temp/hits.in";
	
	ofstream fout;
	fout.open(extinfile.c_str());
	
	for(hitRecordSet::iterator j=hrs.rec.begin();
  	j!=hrs.rec.end();
	j++)
	{
		fout<<((orientation==ORI_53)?reverseString((*j).second.match):(*j).second.match)<<endl;	
	}	
	
	fout.close();
	
}

void load_output_from_extern_score(Primer_data&pmdata)
{
	string extoutfile=cio["CORE_PLUGIN_TEMP OUT"];//"plugin/temp/score.out";
	
	pmdata.becomeOwner();
	pmdata.scores->loadFile(extoutfile);
	
	cout<<"dumping ...\n";
	pmdata.scores->dump();
	cout<<"end ...\n";
}
  
void extern_score(Primer_data &pmdata,hitRecordSet &hrs,int orientation=ORI_53)
{
	string extcmd=cio["CORE_PLUGIN_SCORER_CMD"];//php -f
	//string extmethod=cio["CORE_PLUGIN_SCORER_METHOD"];//"allscores";
	//string extmethodpath=cio["CORE_PLUGIN_SCORER_METHOD PATH"];//"plugin/php-scorer/";
	string extmethodexec=cio["CORE_PLUGIN_SCORER_METHOD"];//extmethodpath+extmethod+".plugin";
	string syscmd=extcmd+" "+extmethodexec;
	write_input_for_extern_score(hrs,orientation);
	
		//cerr<<"calling "<<syscmd<<endl;
		GUIV_SHOWPROGRESS(string("calling plugin ")+syscmd);
	system(syscmd.c_str());
		GUIV_SHOWPROGRESS("plugin returns");
		//cerr<<"ext done"<<endl;
	load_output_from_extern_score(pmdata);
	
	
}

 
void perform_real_stuff(  primerSet &pmrSet,perCallBack _clb=NULL)
{

  
  cout << "======================================" <<endl;
  cout << "+  SNP Genotyping Primer Designer    +" << endl;
  cout << "+                version alpha       +" << endl;
  cout << "======================================" << endl;
  
  //pd_loadSetting(argc,argv);
  

  
  string primer3seqfile;
  string primer3seqprocessed;
  string blastdbfile;
  int snploc;
  int gs;
  int sizefed;
  
  
  snploc=atoi(cio["CORE_SNP_LOC"].c_str());
  gs=atoi(cio["CORE_GARANTEE SIZE"].c_str());
  sizefed=atoi(cio["CORE_PRIMER3_SIZEFED"].c_str());
  blastdbfile=cio["CORE_BLAST_DATABASE PATH"]+"/"+cio["CORE_BLAST_CONTIG FILENAME"];
  
  
  if(cio["CORE_SNP_CONTIG PATH"]=="[rfb]")   
     primer3seqfile=blastdbfile;
  else
     primer3seqfile=cio["CORE_SNP_CONTIG PATH"];
  
  GUIV_SHOWPROGRESS("preparing for primer3....");
  GUIV_SHOWPROGRESS("loading fasta sequence to feed into primer3");
  fasta.loadFastaFile(primer3seqfile,snploc-sizefed-1,sizefed*2);
  
  
  if(cio["CONSOLE_SHOW FED SEQUENCE"]=="YES")
   cout<<"FED SEQUENCE="<<fasta.getSequence()<<endl;
  
   
   
  primer3seqprocessed=cio["CORE_PRIMER3_TEMP PATH"]+"/seq.txt";
  
  
  ofstream fout;
  fout.open(primer3seqprocessed.c_str(),ios::trunc);
  fout<<"SEQUENCE="<<fasta.getSequence();
  fout.close();

    cout<<"Primer3ing ..... "<<endl;   
  GUIV_SHOWPROGRESS("primer3ing....");
  
  pmrSet=primer_main(primer3seqprocessed,
  	      fasta.global2Local(snploc),
	      gs,
	      cio["CORE_PRIMER3_CONSTRAINTS"],
	      cio["CORE_PRIMER3_TEMP PATH"]+"/input.txt",
	      cio["CORE_PRIMER3_TEMP PATH"]+"/output.txt",
	      cio["CORE_PRIMER3_BIN PATH"],
	      (cio["CONSOLE_SHOW PRIMER ADAPTOR RESULT"]=="YES")
	     );
  
	   primerSet::iterator i,j;  
	   
  
   hitRecordSet hrs;
   advMap<string,Primer_data> BLASTSTORE;
   	
	double mismatchK=atof(cio["CORE_SCORE_MISMATCH K"].c_str());
	double matchK=atof(cio["CORE_SCORE_MATCH K"].c_str());
   int cur=0;
   int nur=pmrSet.leftPrimers.size();
   
   int lefPrimer;
   int rigPrimer;
   
   lefPrimer=0;
   rigPrimer=0;
   
  GUIV_SHOWPROGRESS(string("primer3ing returns ")+strof(nur)+" pairs of primers");
  GUIV_SHOWPROGRESS("Blasting and Scoring..... ");  
   cout<<"Blasting and Scoring..... "<<endl;	     
  for(i=pmrSet.leftPrimers.begin(),
      j=pmrSet.rightPrimers.begin();
  	i!=pmrSet.leftPrimers.end(),
	j!=pmrSet.rightPrimers.end();
	i++,
	j++
	)
	{
	

		
	(*i).partner=&(*j);
	(*j).partner=&(*i);
	
	if(BLASTSTORE["L"+(*i).seq.toString()].score==-1000)
	{
//	cerr<<"blasting \""<<(*i).seq.toString()<<"\"..."<<endl;
	hrs=blast(cio["CORE_QUERY NAME"],
  	cio["CORE_BLAST_BIN PATH"],
	cio["CORE_BLAST_TEMP PATH"],
	cio["CORE_BLAST_TEMP PATH"],
	blastdbfile,
	(*i).seq.toString(),
	(cio["CONSOLE_SHOW BLAST ADAPTOR RESULT"]=="YES")

	);
	
	(*i).primerName=(string)"L"+strof(lefPrimer);
	lefPrimer++;
	(*i).score=10000;
	//cerr<<"size of svec:" << (*i).svec.size()<<endl;
//	cerr<<"score="<<(*i).score<<endl;
	BLASTSTORE("L"+(*i).seq.toString()).score=(*i).score;
	BLASTSTORE("L"+(*i).seq.toString()).svec=(*i).svec;
	
	extern_score((*i),hrs,ORI_53);
	BLASTSTORE("L"+(*i).seq.toString()).scores=(*i).scores;	
	BLASTSTORE("L"+(*i).seq.toString()).primerName=(*i).primerName;
	
//	cerr<<"remembering "<<BLASTSTORE["L"+(*i).seq.toString()].score<<endl;
	}else
	{
	(*i).score=BLASTSTORE["L"+(*i).seq.toString()].score;	
	(*i).svec=BLASTSTORE["L"+(*i).seq.toString()].svec;
	(*i).primerName=BLASTSTORE["L"+(*i).seq.toString()].primerName;
	if(!BLASTSTORE["L"+(*i).seq.toString()].scores)
		cerr<<"err scores empti\n";
	
	(*i).becomeSharer(BLASTSTORE["L"+(*i).seq.toString()].scores);
	
	//cerr<<"size of svec:" << (*i).svec.size()<<endl;	
		
//	cerr<<"acquiring "<<BLASTSTORE["L"+(*i).seq.toString()]<<endl;
	
	}



	if(BLASTSTORE["R"+(*j).seq.toString()].score==-1000)
	{
//	cerr<<"blasting \""<<(*j).seq.toString()<<"\"..."<<endl;
	hrs=blast(cio["CORE_QUERY NAME"],
  	cio["CORE_BLAST_BIN PATH"],
	cio["CORE_BLAST_TEMP PATH"],
	cio["CORE_BLAST_TEMP PATH"],
	blastdbfile,
	(*j).seq.reverse_DNA().getComplement().toString(),
	(cio["CONSOLE_SHOW BLAST ADAPTOR RESULT"]=="YES")
	
	);
	
	
	(*j).primerName=(string)"R"+strof(rigPrimer);
	rigPrimer++;	
//	cerr<<"going to score"<<endl;	
	(*j).score=10000;
//	cerr<<"score="<<(*j).score<<endl;
	BLASTSTORE("R"+(*j).seq.toString()).score=(*j).score;
	BLASTSTORE("R"+(*j).seq.toString()).svec=(*j).svec;
	BLASTSTORE("R"+(*j).seq.toString()).primerName=(*j).primerName;
	
//	cerr<<"remembering "<<BLASTSTORE["R"+(*j).seq.toString()]<<endl;
	extern_score((*j),hrs,ORI_35);
	BLASTSTORE("R"+(*j).seq.toString()).scores=(*j).scores;	
	}else
	{
	(*j).score=BLASTSTORE["R"+(*j).seq.toString()].score;	
	(*j).svec=BLASTSTORE["R"+(*j).seq.toString()].svec;
	(*j).primerName=BLASTSTORE["R"+(*j).seq.toString()].primerName;
	
		
	if(!BLASTSTORE["R"+(*j).seq.toString()].scores)
		cerr<<"err scores empti\n";
	
	(*j).becomeSharer(BLASTSTORE["R"+(*j).seq.toString()].scores);
//	cerr<<"acquiring "<<BLASTSTORE["R"+(*j).seq.toString()]<<endl;
	
	}
	
	
		if(_clb)
			(*_clb)(++cur,nur);
	}
	
	
	

}

#ifndef GUI_VERSION

int main(int argc, char *argv[])
{
   pd_loadSetting(argc,argv); 
    primerSet pmrSet;
    
   perform_real_stuff(pmrSet);
  displayResult(pmrSet,fasta);	  
  
  return EXIT_SUCCESS;

}

#endif
