/***************************************************************


    Filename: bas.h
    Author: Cheng Wu Albert
    E-mail: bc_cwa@stu.ust.hk

    Description: The implementation of an Base Object class for ScorAut

****************************************************************/

#ifndef __BAS
#define __BAS

#include <map>
#include <iostream>
#include <vector>
#include <string.h>
using namespace std;

#ifndef NULL
#define NULL 0
#endif

string hex256(int _d)
{
	char s[10];
	sprintf(s,"%X",_d%256);
	if(strlen(s)==1)
	{
		s[2]='\0';
		s[1]=s[0];
		s[0]='0';
	}
	return s;
}

string strof(int _d)
{
	char s[10];
	sprintf(s,"%d",_d);
	return s;
}

string stroffill(int _d,int _fill)
{
	string s;
	s=strof(_d);
	string prefix;
	
	for(int i=s.length();i<_fill;i++)
	{
		prefix+="0";
	}
	
	return prefix+s;
	
}
string strof2(double _d)
{
	char s[10];
	sprintf(s,"%.2f",_d);
	int n=strlen(s);
	
	/*if(_d-int(_d)==0)
		for(int i=n-1;i>0;i--)
		{
		if(s[i]!='0' && s[i]!='.')
			break;
		s[i]='\0';
		
		
		}*/
	return s;
}

class bas
{
	public:
	virtual void printType(const char* _typeName=NULL) const;

};

void bas::printType(const char* _typeName) const
{
		if(_typeName)
			cout<<_typeName<<endl;
		else
			cout<<"unknown Type"<<endl;
}


typedef vector<string> strVector;





template<class K,class V>
class advMap: public map<K,V>
{



  public:
  V errorObj;

	

  void setErrorObject(const V& _errorObj);
  advMap(const V &_errorObj=V() ):errorObj(_errorObj){}
  V &operator[](const K& _key);
  V &operator()(const K& _key); //add New
  bool operator-=(const K& _key); //remove var 

  bool delVal(const K& _key);
  void setVal(const K& _key, const V &_val);
  bool isErrorObj(const V& _obj) const;
  bool operator<<(const V& _obj) const;
  friend ostream& operator <<(ostream& _os,const advMap<K,V>& _map);
};


template<class K, class V>
ostream& operator <<(ostream& _os,const advMap<K,V>& _map)
{
	advMap<K,V>::const_iterator i;
	for(i=_map.begin(); i!=_map.end();i++)
	{
		_os<<(*i).first<<"=" <<(*i).second<<endl;
	}

	return _os;
}

template<class K,class V>
bool advMap<K,V>::operator -=(const K& _key)
{
	return delVal(_key);
}

template<class K,class V>
bool advMap<K,V>::delVal(const K& _key)
{
	map<K,V>::iterator i=find(_key);

	if(i==end())
		return false;

	map<K,V>::erase(i);

	return true;
}




template<class K,class V>
bool advMap<K,V>::operator <<(const V& _obj) const
{
	return isErrorObj(_obj);
}

template<class K,class V>
bool advMap<K,V>::isErrorObj(const V& _obj) const
{
	return &errorObj==&_obj;
}


template<class K,class V>
void advMap<K,V>::setErrorObject(const V& _errorObj)
{
	errorObj=_errorObj;

}

template<class K,class V>
V &advMap<K,V>::operator[](const K &_key)
{
  
	map<K,V>::iterator i;
  
  i=find(_key);
  if(i==end())
    return errorObj;

  return (*i).second;
  

}

template<class K,class V>
V &advMap<K,V>::operator()(const K &_key)
{
  
  map<K,V>::iterator i;
  
  i=find(_key);
  if(i==end())
  {

	  setVal(_key,V());
	  i=find(_key);
  }

  return (*i).second;
  

}

template<class K,class V>
void advMap<K,V>::setVal(const K& _key, const V &_val)
{
  V *addrmod;
  addrmod=&((*this)[_key]);
  if(addrmod==&(this->errorObj))
    insert(value_type(_key,_val));
  else
    (*addrmod)=_val;
}

advMap<string,string> ESCMAP("");
int k();

void initAdvMap()
{
    
    ESCMAP.setVal("n","\n");
    ESCMAP.setVal("t","\t");
    ESCMAP.setVal("r","\r");
    ESCMAP.setVal("\"","\"");
    ESCMAP.setVal("\\","\\");
	ESCMAP.setVal(",",";");
    
}


string evalEscapedString(string _str,bool _removeFlanker=true)
{
  if(ESCMAP.size()<1)
  initAdvMap();
    
  string r;
  int i,len;
  len=_str.length();

  if(len<1)
    return "";
    
  if(_removeFlanker)
  {
    if(_str[len-1]=='"')
      _str.erase(len-1,1);

    if(_str[0]=='"')
      _str.erase(0,1);

  }
  
  len=_str.length();

  
  for(i=0;i<len;i++)
  {
    if(_str[i]=='\\' && i<len-1)
      r.append(ESCMAP[_str.substr(++i,1)]);
    else
      r.append(_str.substr(i,1));
     
  }


  return r;
}

double valOf(const string& _num)
{
	return atof(_num.c_str());

}

char* cpystr(const char* str)
{
	char *buf;
	buf=new char[strlen(str)+1];
	strcpy(buf,str);
	return buf;
}


strVector str_split(string _subject,const string& _sep)
{
	strVector vret;
	char* strpar=cpystr(_subject.c_str());
	char* buf;
	char* sub;
	sub=strpar;
	

	do
	{
		buf=strtok(sub,_sep.c_str());
		sub=NULL;
		string s;
		
		if(buf)
			vret.push_back(buf);
	}while(buf);
	
	delete[] strpar;
	
	return vret;

}



vector<double> str_split_double(string _subject,const string& _sep)
{
	vector<double> vret;
	char* strpar=cpystr(_subject.c_str());
	char* buf;
	char* sub;
	sub=strpar;
	

	do
	{
		buf=strtok(sub,_sep.c_str());
		sub=NULL;
		string s;
		
		if(buf)
			vret.push_back(atof(buf));
	}while(buf);
	
	delete[] strpar;
	
	return vret;

}
ostream& operator<<(ostream& os,const strVector& vet)
{
	strVector::const_iterator i;
	for(i=vet.begin();i!=vet.end();i++)
	{
		os<<(*i)<<".";
	}
	os<<endl;

	return os;
	
}

strVector translateAddr(const string& _str)
{
	return str_split(_str,":");
}

bool bool_xor(bool _left,bool _right)
{
	if(_left==_right)
		return false;

	return (_left||_right);
}

strVector chopString(const string& _str,int _partition_size)
{
	strVector v;
	
	int len;
	len=_str.length();

	for(int n=0;n<_str.length();n+=_partition_size)
	{
		v.push_back(_str.substr(n,_partition_size));
	}
	return v;
}

#endif
