#ifndef __CONFIG_IO
#define __CONFIG_IO

#define CONFIG_BUFFER_SIZE 1024
#define CONFIG_PARTITION_SIZE	   -1
#define CONFIG_SIGNATURE	"//Created by ConfigIO"
#define CONFIG_REDIRECTOR	"|->|"
#define CONFIG_REDIRECTOR_LENGTH 4


#include "bas.h"
#include <fstream>
using namespace std;

template<class K,class V>
class configIO:public advMap<K,V>
{
	private:

		string filename;
	public:
		configIO(string _errString="",string _filename=""):advMap<K,V>(V(_errString))
		{
			filename=_filename;
	
			if(_filename!="")
			loadFile(filename);
		}

		void loadFile(string _filename,bool _append=false);
		void saveFile(string _filename,bool _append=false,bool _sign=false);
		void dump();
};

template<class K,class V>
void configIO<K,V>::dump()
{
	advMap<K,V>::iterator i;
	for(i=begin();i!=end();i++)
	{
		cout<<(*i).first<<"="<<(*i).second<<endl;
	
	}

}


template<class K,class V>
void configIO<K,V>::loadFile(string _filename,bool _append)
{
		ifstream fin;

	if(_filename=="")
		return;
	
	if(!_append)
		clear();

	filename=_filename;
	
	string prevKey="";

	fin.open(_filename.c_str());

	strVector strv;
	char buffer[CONFIG_BUFFER_SIZE];
//	cout<<"op "<<filename<<endl;
	bool signRead=false;

	while(!fin.eof())
	{
		if(fin.eof())
			break;

		fin.getline(buffer,CONFIG_BUFFER_SIZE);
		
//		cout<<"{"<<filename<<"}"<<buffer<<endl;
		if(!strcmp(buffer,"")) 
			continue;

		if(!strncmp(buffer,"//",2)) 
			continue;

		if(!strcmp(buffer,CONFIG_SIGNATURE) && !signRead)
		{
			signRead=true;

			continue;
		}
		string toset;

		if(!strncmp(buffer,CONFIG_REDIRECTOR,CONFIG_REDIRECTOR_LENGTH))
		{
			(*this)[prevKey]+=buffer+4;
			continue;
		}

		strv=str_split(buffer,"=");
		if(strv.size()>=2)
		{
			prevKey=strv[0];
			toset=strv[1];
			for(int j=2;j<strv.size();j++)
				toset+="="+strv[j];

			setVal(strv[0],toset);
		}
		else if(strv.size()==1 && prevKey!="")
		{
			(*this)[prevKey]+=strv[0];
		}
			

			
	}

	fin.close();

}

template<class K,class V>
void configIO<K,V>::saveFile(string _filename,bool _append,bool _sign)
{
		ofstream fout;
	if(_filename=="")
		return;
	
	filename=_filename;
	
	if(_append)
		fout.open(_filename.c_str(),ios::app);
	else
		fout.open(_filename.c_str(),ios::trunc);

	strVector strv;

//	cout<<"sa "<<filename<<endl;
	string k;
	string v;
	string w;
	
	if(_sign)
		fout<<CONFIG_SIGNATURE<<endl;

	bool seca;

	advMap<K,V>::iterator i;
	for(i=begin();i!=end();i++)
	{
		k=(*i).first;
		v=(*i).second;
		w=k+"="+v;
		//cerr<<"outing "<<w<<endl;
		if(w.length()>CONFIG_PARTITION_SIZE && CONFIG_PARTITION_SIZE>0)
		{
			strVector vec;
			seca=false;
			vec=chopString(w,CONFIG_PARTITION_SIZE);
			for(strVector::iterator i=vec.begin();
				i!=vec.end();
				i++)
				{
					if(seca)	
					{				
					fout<<CONFIG_REDIRECTOR;	
					}
					fout<<(*i)<<endl;
					seca=true;

				}
		}
		else
			fout<<w<<endl;
		
	}

	fout.close();

}

#endif
