#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

#ifndef X_
#define X_


class Biostring{

};

class PeptideString{
public:
	void Output();
private:
	string aaseq; 
	int len; 

friend class NucleoString;
};

void PeptideString::Output(){
	for (int i=0; i<len; i++)
		cout<<aaseq[i];
	cout<<endl;
}

class NucleoString:public Biostring{
public:
    NucleoString(){
		len=0; 
		naseq="";
	};
	NucleoString(string seq){
		for (int i=0; i<seq.size(); i++){
			seq[i]=toupper(seq[i]);
		};
		naseq=seq;
		len=seq.size();
	};
	NucleoString(const NucleoString& N){
		naseq=N.naseq;
		len=N.len;
	};
	NucleoString reverse_DNA(){
		NucleoString reversed_DNA;
	    reversed_DNA.len=len;
	    for(int i=naseq.size()-1; i>=0; i--){
			reversed_DNA.naseq+=naseq[i];
		};
	    return reversed_DNA;
	};
	NucleoString& operator= (const NucleoString& N);
	
	void operator=(string seq);
	 string toString();
	
	NucleoString getComplement();
    NucleoString getPalindrome();
    PeptideString translate();
    NucleoString toRNA();
    NucleoString toDNA();
	void summary(int &GCount,int &ACount,int &TCount,int &CCount);
    int length();
	NucleoString ORF();
	void Output();

private:
    string naseq;
	int len;
};

NucleoString& NucleoString::operator= (const NucleoString& N)
{
  len=N.len;
  naseq=N.naseq;
  return *this;
}

void NucleoString::operator= (string seq)
{
	for (int i=0; i<seq.size(); i++){
			seq[i]=toupper(seq[i]);
		};
		naseq=seq;
		len=seq.size();
}

string NucleoString::toString()
{
  return naseq;
}

NucleoString NucleoString::getComplement(){
	NucleoString complement;
	
	complement.len=len;
	for (int i=0;i<len;i++){
		if (naseq[i]=='A' || naseq[i]=='a')
			complement.naseq+="T";
		if (naseq[i]=='T' || naseq[i]=='t')
			complement.naseq+="A";
		if (naseq[i]=='C' || naseq[i]=='c')
			complement.naseq+="G";
		if (naseq[i]=='G' || naseq[i]=='g')
			complement.naseq+="C";
	};
	return complement;
}

NucleoString NucleoString::getPalindrome(){
	NucleoString PalindromeDNA;
   
	PalindromeDNA.len=len;
	for (int i=len-1; i>=0; i--){
		if (naseq[i]=='A' || naseq[i]=='a')
			PalindromeDNA.naseq+="T";
		if (naseq[i]=='T' || naseq[i]=='t')
			PalindromeDNA.naseq+="A";
		if (naseq[i]=='C' || naseq[i]=='c')
			PalindromeDNA.naseq+="G";
		if (naseq[i]=='G' || naseq[i]=='g')
			PalindromeDNA.naseq+="C";
	};
	return PalindromeDNA;
}

PeptideString NucleoString::translate(){
	PeptideString P;
	string codon;
	
	P.len=len;
	for (int i=0; i<=len; i+=3){
		if (i+2<=len){
			codon=naseq.substr(i,3);
			if (codon=="UUU" || codon=="UUC")
				P.aaseq+="F";
			if (codon=="UUA" || codon=="UUG")
				P.aaseq+="L";
			if (codon=="CUU" || codon=="CUC" || codon=="CUA" || codon=="CUG")
				P.aaseq+="L";
			if (codon=="AUU" || codon=="AUC" || codon=="AUA" || codon=="AUG")
				P.aaseq+="I";
			if (codon=="GUU" || codon=="GUC" || codon=="GUA" || codon=="GUG")
				P.aaseq+="V";
			if (codon=="UCU" || codon=="UCC" || codon=="UCA" || codon=="UCG")
				P.aaseq+="S";
			if (codon=="CCU" || codon=="CCC" || codon=="CCA" || codon=="CCG")
				P.aaseq+="P";
			if (codon=="ACU" || codon=="ACC" || codon=="ACA" || codon=="ACG")
				P.aaseq+="T";
			if (codon=="GCU" || codon=="GCC" || codon=="GCA" || codon=="GCG")
				P.aaseq+="A";
			if (codon=="UAU" || codon=="UAC")
				P.aaseq+="Y";
			if (codon=="UAA" || codon=="UAG" || codon=="UGA")
				P.aaseq+="/";
			if (codon=="CAU" || codon=="CAC")
				P.aaseq+="H";
			if (codon=="CAA" || codon=="CAG")
				P.aaseq+="Q";
			if (codon=="AAU" || codon=="AAC")
				P.aaseq+="N";
			if (codon=="AAA" || codon=="AAG")
				P.aaseq+="K";
			if (codon=="GAU" || codon=="GAC")
				P.aaseq+="D";
			if (codon=="GAA" || codon=="GAG")
				P.aaseq+="E";
			if (codon=="UGU" || codon=="UGC")
				P.aaseq+="C";
			if (codon=="UGG")
				P.aaseq+="W";
			if (codon=="CGU" || codon=="CGC" || codon=="CGA" || codon=="CGG")
				P.aaseq+="R";
			if (codon=="GGU" || codon=="GGC" || codon=="GGA" || codon=="GGG")
				P.aaseq+="G";
			if (codon=="AGU" || codon=="AGC")
				P.aaseq+="S";
			if (codon=="AGA" || codon=="AGG")
				P.aaseq+="R";
		};
	}
	return P;
}

NucleoString NucleoString::toDNA(){
	NucleoString DNA;
	DNA.len=len;
	DNA.naseq=naseq;
	for (int i=0; i<=len; i++){
		if (naseq[i]=='U' || naseq[i]=='u')
			DNA.naseq[i]='T';
		else
			DNA.naseq[i]=naseq[i];
	};
	return DNA;
}

NucleoString NucleoString::toRNA(){
	NucleoString RNA;
	RNA.len=len;
	RNA.naseq=naseq;
	for (int i=0; i<=len; i++){
		if (naseq[i]=='T' || naseq[i]=='t')
			RNA.naseq[i]='U';
		else
			RNA.naseq[i]=naseq[i];
	};
	return RNA;
}

void NucleoString::summary(int &GCount,int &ACount,int &TCount,int &CCount){
	GCount=ACount=TCount=CCount=0;
	for (int i=0; i<len; i++){
		if (naseq[i]=='A' || naseq[i]=='a')
			ACount++;
		if (naseq[i]=='C' || naseq[i]=='c')
			CCount++;
		if (naseq[i]=='T' || naseq[i]=='t')
			TCount++;
		if (naseq[i]=='G' || naseq[i]=='g')
			GCount++;
	}
}

int NucleoString::length(){
	return len;
}

NucleoString NucleoString::ORF(){
	NucleoString codingDNA;
	int start=0;
	int end=0;
	for (int i=0; i<=len; i++){
		if (naseq.substr(i,3)=="AUG"){
			start=i;
			for (int j=i+3; j<=len; j+=3){
				if (naseq.substr(j,3)=="UAA"||naseq.substr(j,3)=="UAG"||naseq.substr(j,3)=="UGA"){
					end=j;
				}
			}
		}
	};
	codingDNA.naseq=naseq.substr(start,(end+2-start+1));
    codingDNA.len=end+2-start+1;
	return codingDNA;
}

void NucleoString::Output(){
	for (int i=0; i<len; i++)
		cout<<naseq[i];
	cout<<endl;
};

#endif
