#include <iostream>
#include <stdlib.h>
#include <string>

#include "biostring.h"
#include <vector>

#define PRINT_MODE_SIMPLE  0
#define PRINT_MODE_SHOW_BASE_SCORE 1

#define MODE_NULL 0
#define MODE_OWNER 1
#define MODE_SHARER 2


class Primer_data{
	public:
		Primer_data(){partner=NULL;score=-1000;
		scoreMode=MODE_NULL;
			scores=NULL;
		
		};
		~Primer_data(){
		  if(scores && scoreMode==MODE_OWNER)
		  	delete scores;
		
		};
	
    		Primer_data(int  p, int l, NucleoString s){
			position=p;
			len=l;
			seq=s;
			partner=NULL;
			score=-1000;
			scoreMode=MODE_NULL;
			scores=NULL;
		};
		

		string primerName;
		int position;
		int len;
		NucleoString seq;
		double score;
		Primer_data *partner;
		vector<double> svec;
		configIO<string,string> *scores;
		int scoreMode;
		string getSvecSeq();
		string getPosSeq(fastaLoader *_loader);
		void print(int _mode=PRINT_MODE_SIMPLE,fastaLoader *_loader=NULL);
		void becomeOwner();
		void becomeSharer(configIO<string,string> *_scores);
		vector<double> refreshSeqScore(string which);
		double refreshSingleScore(string which);
		
		
		
		
};
 
double Primer_data::refreshSingleScore(string which)
{
	if(scores)
	{
		score=atof((*scores)[which].c_str());
	}
	else
		cerr<<"ss score not \n";
		
	return score;
}
 
vector<double> Primer_data::refreshSeqScore(string which)
{
	if(scores)
		svec=str_split_double((*scores)[which],",");
	else
		cerr<<"svec score not \n";	
	return svec;
}

void Primer_data::becomeOwner()
{
	if(scores)
		return;
	
	scores=new configIO<string,string>;
	scoreMode=MODE_OWNER;
}

void Primer_data::becomeSharer(configIO<string,string> *_scores)
{
	  if(scores && scoreMode==MODE_OWNER)
		  	delete scores;
	
	scores=_scores;
	scoreMode=MODE_SHARER;
	
}

string Primer_data::getSvecSeq()
{	
	vector<double>::iterator i;
	string str;
	for(i=this->svec.begin();
		i!=this->svec.end();
		i++)
		{
			str+=".";
			str+=strof((int)(*i));
				
		}
	
	return str;
	
}
string Primer_data::getPosSeq(fastaLoader *_loader)
{	
	vector<double>::iterator i;
	string str;
	str+=primerName+" ";
	str+=strof(((_loader)?_loader->local2Global(position):position));
	str+=",";
	str+=strof(len);
	str+=" ";
	str+=seq.toString();
	
	return str;
	
}
void Primer_data::print(int _mode,fastaLoader *_loader)
{
	//vector<double> svec;
	vector<double>::iterator i;

	
	switch(_mode)
	{
		case PRINT_MODE_SIMPLE:
		
			cout<<((_loader)?_loader->local2Global(position):position)<<","<<len<<" "<<seq.toString();
		break;
		case PRINT_MODE_SHOW_BASE_SCORE:
			cout<<((_loader)?_loader->local2Global(position):position)<<","<<len<<" "<<seq.toString()<<"\t";
			for(i=this->svec.begin();
				i!=this->svec.end();
				i++)
				{
					cout<<"."<<(int)(*i);
				
				}
		break;
		default:
			break;
	}

}

